package com.example.vaadincustomlayout;

import com.uniyaz.main.layouts.PageLayout;
import com.vaadin.annotations.PreserveOnRefresh;
import com.vaadin.annotations.Theme;
import com.vaadin.server.VaadinRequest;
import com.vaadin.ui.Layout;
import com.vaadin.ui.TabSheet;
import com.vaadin.ui.TabSheet.SelectedTabChangeEvent;
import com.vaadin.ui.TabSheet.SelectedTabChangeListener;
import com.vaadin.ui.TabSheet.Tab;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

/**
 * Main UI class
 */
@Theme("FlexCityTheme")
@SuppressWarnings("serial")
@PreserveOnRefresh
public class VaadincustomlayoutUI extends UI {
    private VerticalLayout mainLayout;
    private TabSheet tabSheetMain;

    @Override
    protected void init(VaadinRequest request) {

        mainLayout = new VerticalLayout();
        tabSheetMain = new TabSheet();
        tabSheetMain.addTab(new VerticalLayout(), "Main");
        tabSheetMain.addTab(new VerticalLayout(), "TestPage");

        tabSheetMain
                .addSelectedTabChangeListener(new SelectedTabChangeListener() {

                    private static final long serialVersionUID = 1L;

                    @Override
                    public void selectedTabChange(SelectedTabChangeEvent event) {

                        TabSheet tabSheetInEvent = event.getTabSheet();
                        int tabIndex = tabSheetInEvent
                                .getTabPosition(tabSheetInEvent
                                        .getTab(tabSheetInEvent
                                                .getSelectedTab()));
                        Tab selectedTab = tabSheetInEvent.getTab(tabIndex);
                        Layout selectedLayout = (Layout) selectedTab
                                .getComponent();

                        if (selectedTab.getCaption().equalsIgnoreCase(
                                "TestPage")) {
                            PageLayout pageLayout = new PageLayout();
                            tabSheetMain.replaceComponent(selectedLayout,
                                    pageLayout);
                        } else {
                            tabSheetMain.replaceComponent(selectedLayout,
                                    new VerticalLayout());
                        }

                    }
                });

        mainLayout.addComponent(tabSheetMain);

        setContent(mainLayout);

    }

}